unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, TeeScrollPagerTool, Series, TeeProcs, Chart, StdCtrls,
  ExtCtrls, Unit2;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BShowModalTop: TButton;
    Chart1: TChart;
    Panel2: TPanel;
    BShowModalBottom: TButton;
    Series1: TBarSeries;
    Series2: TBarSeries;
    ChartTool1: TScrollPagerTool;
    procedure BShowModalTopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BShowModalBottomClick(Sender: TObject);
  private
    { Private declarations }
    procedure OpenChartInModal(AChart: TChart);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var Chart2: TChart;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Chart2:=TChart.Create(Self);
  with Chart2 do
  begin
    Parent:=Self;
    Align:=alClient;
    Title.Caption:='Chart created at runtime';

    View3D:=False;
    Legend.Hide;

    with AddSeries(TBarSeries) do
    begin
      Marks.Hide;
      FillSampleValues(30);
    end;

    Tools.Add(TScrollPagerTool);
  end;
end;

procedure TForm1.OpenChartInModal(AChart: TChart);
var wc: twincontrol;
    btn: TButton;
begin
  if AChart=Chart1 then
     btn:=BShowModalTop
  else
     btn:=BShowModalBottom;

  Form2.Caption:='Test for ' + AChart.Title.Caption;
  wc:=AChart.Parent;

  AChart.Parent:=Form2;
  btn.Visible:=false;

  Form2.ShowModal;
  btn.Visible:=true;

  AChart.Parent:=wc;
end;

procedure TForm1.BShowModalTopClick(Sender: TObject);
begin
  OpenChartInModal(Chart1);
end;

procedure TForm1.BShowModalBottomClick(Sender: TObject);
begin
  OpenChartInModal(Chart2);
end;

end.
